package com.faraphel.tasks_valider.database.dao

import androidx.room.Dao
import androidx.room.Query
import com.faraphel.tasks_valider.database.dao.base.BaseCronDao
import com.faraphel.tasks_valider.database.dao.base.BaseSessionDao
import com.faraphel.tasks_valider.database.dao.base.BaseTaskDao
import com.faraphel.tasks_valider.database.entities.ClassEntity
import com.faraphel.tasks_valider.database.entities.RelationClassPersonEntity
import com.faraphel.tasks_valider.database.entities.SessionEntity

@Dao
interface RelationClassPersonDao : BaseTaskDao<RelationClassPersonEntity> {
    @Query("SELECT * FROM ${RelationClassPersonEntity.TABLE_NAME}")
    override fun getAll(): List<RelationClassPersonEntity>

    @Query(
        "SELECT ${RelationClassPersonEntity.TABLE_NAME}.* FROM ${RelationClassPersonEntity.TABLE_NAME} " +
        "JOIN ${ClassEntity.TABLE_NAME} " +
        "ON ${RelationClassPersonEntity.TABLE_NAME}.class_id = ${ClassEntity.TABLE_NAME}.id " +
        "JOIN ${SessionEntity.TABLE_NAME} " +
        "ON ${SessionEntity.TABLE_NAME}.class_id = ${ClassEntity.TABLE_NAME}.id " +
        "WHERE ${SessionEntity.TABLE_NAME}.id = :sessionId"
    )
    override fun getAllBySession(sessionId: Long): List<RelationClassPersonEntity>

    /**
     * Get the object from its identifiers
     */
    @Query(
        "SELECT * FROM ${RelationClassPersonEntity.TABLE_NAME} " +
        "WHERE class_id = :classId " +
        "AND student_id = :studentId"
    )
    fun getById(classId: Long, studentId: Long): RelationClassPersonEntity?
}
