package com.faraphel.tasks_valider.database.dao

import androidx.room.Dao
import androidx.room.Query
import com.faraphel.tasks_valider.database.dao.base.BaseCronDao
import com.faraphel.tasks_valider.database.dao.base.BaseSessionDao
import com.faraphel.tasks_valider.database.dao.base.BaseTaskDao
import com.faraphel.tasks_valider.database.entities.ClassEntity
import com.faraphel.tasks_valider.database.entities.SessionEntity

@Dao
interface SessionDao : BaseTaskDao<SessionEntity> {
    @Query("SELECT * FROM ${SessionEntity.TABLE_NAME}")
    override fun getAll(): List<SessionEntity>

    @Query("SELECT * FROM ${SessionEntity.TABLE_NAME} WHERE id = :sessionId")
    override fun getAllBySession(sessionId: Long): List<SessionEntity>

    /**
     * Get the object from its identifier
     */
    @Query("SELECT * FROM ${SessionEntity.TABLE_NAME} WHERE id = :id")
    fun getById(id: Long): SessionEntity?
}
