package com.faraphel.tasks_valider.database.dao

import androidx.room.Dao
import androidx.room.Query
import com.faraphel.tasks_valider.database.dao.base.BaseCronDao
import com.faraphel.tasks_valider.database.dao.base.BaseSessionDao
import com.faraphel.tasks_valider.database.dao.base.BaseTaskDao
import com.faraphel.tasks_valider.database.entities.RelationPersonSessionSubjectEntity
import com.faraphel.tasks_valider.database.entities.TaskEntity
import com.faraphel.tasks_valider.database.entities.ValidationEntity

@Dao
interface ValidationDao : BaseTaskDao<ValidationEntity> {
    @Query("SELECT * FROM ${ValidationEntity.TABLE_NAME}")
    override fun getAll(): List<ValidationEntity>

    @Query(
        "SELECT * FROM ${ValidationEntity.TABLE_NAME} " +
        "JOIN ${TaskEntity.TABLE_NAME} " +
        "ON ${ValidationEntity.TABLE_NAME}.task_id = ${TaskEntity.TABLE_NAME}.id " +
        "WHERE ${TaskEntity.TABLE_NAME}.subject_id IN (" +
            "SELECT subject_id FROM ${RelationPersonSessionSubjectEntity.TABLE_NAME} " +
            "WHERE session_id = :sessionId" +
        ")"
    )
    override fun getAllBySession(sessionId: Long): List<ValidationEntity>

    /**
     * Get the object from its identifiers
     */
    @Query(
        "SELECT * FROM ${ValidationEntity.TABLE_NAME} " +
        "WHERE " +
        "teacher_id = :teacherId and " +
        "student_id = :studentId and " +
        "task_id = :taskId"
    )
    fun getById(teacherId: Long, studentId: Long, taskId: Long): ValidationEntity?
}
